<bugID>1356593<Summary>nsISearchEngine.speculativeConnect and nsISearchEngine.getSubmission are slow</Summary><Description>I got this profile by alternatively clicking the searchbar and location bar on a slow netbook: https://perfht.ml/2of8wvm

We spend a lot of time calling speculativeConnect() on the currentEngine. getSubmission is the slow part (and in getSubmission, getLocale is the slowest part).

We should:
- cache most of the submission URL the first time it's computed. Only the user's query terms change each time.
- cache the getLocale result the first time we get it (we get it while initializing the search service... and we do already have a pref observer that triggers an async reinitialization of the search service whenever the locale changes)
- we may want to add a fast path for getting only the prepath of the submission URL for the speculativeConnect code path.</Description></bugID>